package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;

import java.lang.reflect.InvocationTargetException;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author leon on 10/12/2018.
 */
public class Student {

    Map<Lab, LabStatus> map;

    public Student() {

        new Student(new TreeMap<>());
    }

    public Student(Map<Lab, LabStatus> map) {

        this.map = map;
    }

    public void setLabStatus(Lab lab, LabStatus labStatus) {

        if(this.map.isEmpty() || !this.map.containsKey(lab)) {
            throw new UnsupportedOperationException();
        } else {
            this.map.put(lab, labStatus);
        }
    }


    public void forkLab(Lab lab) {

        this.map.put(lab, lab.labStatus);

    }

    public LabStatus getLabStatus(String labName) {
            return this.map.get(findLabByName(labName));
    }

    private Lab findLabByName(String labName) {
        for(Lab l: this.map.keySet()) {
            if (l.getName().equals(labName))
                return l;
        }
        return null;
    }
}
